// onewire.c
#include "onewireHEAD.h"
#include <REGAN21.H>			/* Register des AN21xx	*/
#include <EZRegsHEAD.H>			/* Externe Register des AN21xx  */
#include <intrins.h>

#define DQ 7 // Pin an Port C mir der Datenleitung des Onewire-Bus



void OWWriteByte(unsigned char byte) small {
	unsigned char i;

	for (i = 0; i<8; i++)
		OWWriteBit(!((byte & (1<<i))==0));
}


unsigned char OWReadByte() small {
	unsigned char i, byte;

	byte=0x00;
	for(i=0;i<8;i++) byte |= OWReadBit()<<i;

	return byte;
}



void OWWriteBit(unsigned char Bit) small {
	unsigned char i, j;
						 
	EA = 0; // Interrupts global deaktivieren

	if (Bit)
	{
		i = 0x0C;
		j = 0x75;
	}
	else
	{
		i = 0x60;
		j = 0x21;
	}
	OEC |= (1<<DQ);	// DQ als Ausgang
	OUTC &= ~(1<<DQ);	// DQ auf low	  

	do{
		_nop_();		// ca. 60s (bei 0) oder 9s (bei 1) warten		 																																																																								
	}while(--i);			 
	
	OEC &= ~(1<<DQ);	// DQ als Eingang	

	do{
		_nop_();		// ca. 20s (bei 0) oder 71s (bei 1) warten		 																																																																								
	}while(--j);			 			 

	EA = 1;	// Interrupts wieder aktivieren
}


unsigned char OWReadBit() small {
	unsigned char Bit, i;
						 
	EA = 0; // Interrupts global deaktivieren

	OEC |= (1<<DQ);	// DQ als Ausgang
	OUTC &= ~(1<<DQ);	// DQ auf low	 

	i = 0x0C; 
	do{
		_nop_();		// ca. 9s warten		 																																																																								
	}while(--i);
										
	OEC &= ~(1<<DQ);	// DQ als Eingang
	
	i = 0x0C; 
	do{
		_nop_();		// ca. 9s warten		 																																																																								
	}while(--i);
									
	Bit = ((PINSC & (1<<DQ)) == (1<<DQ));
												 
	i = 0x46; 
	do{
		_nop_();		// ca. 42s warten		 																																																																								
	}while(--i);
			 
	EA = 1;	// Interrupts wieder aktivieren
	return Bit;

}




unsigned char OWReset() small {
	unsigned char i, j, device_presence;

	EA = 0; // Interrupts global deaktivieren

	device_presence = 0;
	i = 0x04;
	j = 0x40;
	OEC |= (1<<DQ);	// DQ als Ausgang
	OUTC &= ~(1<<DQ);	// DQ auf low

	do{  
		do{
			_nop_();		// ca. 500s warten		 
		}while(--j);	// Ein Schleifendurchlauf mit _nop_() bentigt ca. 0.612s																																																																								
	}while(--i);
	
	OUTC |= (1<<DQ);	// DQ auf high
	OEC &= ~(1<<DQ);	// DQ als Eingang

	i = 0x76; 
	do{
		_nop_();		// ca. 72s warten		 																																																																								
	}while(--i);

	device_presence = ((PINSC & (1<<DQ)) == 0);	// DQ = low -> device present; DQ = high -> device not present

	i = 3;
	j = 0x9C;
	do{  
		do{
			_nop_();		// ca. 310s warten		 
		}while(--j);																																																																							
	}while(--i);

	EA = 1;	// Interrupts wieder aktivieren

	return device_presence & (PINSC>>DQ);	// bei Kurzschluss return 0
}


/**************************************************************
_nop_(); // ein _nop_() alleinstehend bentigt ca. 0.15s
**************************************************************/